package br.usp.icmc.lrm.gmarques.srv;

import java.util.List;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.hardware.Sensor;
import android.hardware.SensorManager;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.Window;
import android.view.WindowManager;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Toast;
import br.usp.icmc.lrm.gmarques.srv.network.Connection;
import br.usp.icmc.lrm.gmarques.srv.sensor.SRVSensorEventListenerNoPot;

public class AndroSRV extends Activity {

	Connection conexao;
	String address;
	SensorManager sensorManager;
	SRVSensorEventListenerNoPot sensorEventListener;
	ImageView iv;
	@SuppressWarnings("rawtypes")
	List sensorList;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, 
                WindowManager.LayoutParams.FLAG_FULLSCREEN );
        setContentView(R.layout.main);
		conexao = new Connection();
		iv = (ImageView) findViewById(R.id.picview);
		
		// Inicia acelerometro 
		sensorEventListener = new SRVSensorEventListenerNoPot(conexao);
		sensorManager = (SensorManager) getSystemService(SENSOR_SERVICE);
		sensorList = sensorManager.getSensorList(Sensor.TYPE_ACCELEROMETER);
		if (sensorList.size() > 0)
			sensorManager.registerListener(sensorEventListener,
					(Sensor) sensorList.get(0),
					SensorManager.SENSOR_DELAY_NORMAL);
		else
			Toast.makeText(getBaseContext(),
					"Este aparelho não possui acelerometro", Toast.LENGTH_LONG);

	}

	@Override
	protected void onStop() {
		if (sensorList.size() > 0)
			sensorManager.unregisterListener(sensorEventListener);
		try{
			conexao.sendByte('5');
		}catch(Exception e){}
		super.onStop();
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.menu, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		Context mContext = this;
		switch (item.getItemId()) {
		case R.id.configurar:
			  //Cria o dialogo
			  AlertDialog.Builder alert = new AlertDialog.Builder(mContext);

			  alert.setTitle("SRV-1");
			  alert.setMessage("Entre com IP:PORTA");

			  // Set an EditText view to get user input 
			  final EditText input = new EditText(mContext);
			  input.setText("169.254.0.11:10001");
			  alert.setView(input);

			  alert.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
			  public void onClick(DialogInterface dialog, int whichButton) {
			    String host = input.getText().toString();
			    address = host;
			    connectButton();
			    }
			  });
			  alert.show();
			break;
		case R.id.ligarLaser:
			turnOnLaser();
			break;
		case R.id.desligarLaser:
			turnOffLaser();
			break;
		}
		return true;
	}
	
	public void connectButton() {
		try {
			conexao.connect(address);
			if (conexao.isConnected()) {
				Toast.makeText(super.getBaseContext(),
						"Conexão bem sucessida!!", Toast.LENGTH_SHORT).show();
				try {
					conexao.sendByte('M');
					conexao.sendByte((char) 50);
					conexao.sendByte((char) 50);
					conexao.sendByte((char) 10);
					new AsyncGetImage().execute("teste");
				} catch (Exception e) {
					e.printStackTrace();
				}
			} else
				Toast.makeText(getBaseContext(), "Erro na conexão",
						Toast.LENGTH_SHORT).show();
		} catch (Exception e) {
			Toast.makeText(getBaseContext(), "Erro: " + e.getMessage(),
					Toast.LENGTH_LONG).show();
		}
	}

	public void turnOnLaser() {
		try {

			if (conexao.isConnected()) {
				Toast.makeText(super.getBaseContext(),
						"Laser ON", Toast.LENGTH_SHORT).show();
				conexao.sendByte('l');
			} else
				Toast.makeText(getBaseContext(), "Erro na conexão",
						Toast.LENGTH_SHORT).show();
		} catch (Exception e) {
			Toast.makeText(getBaseContext(), "Erro: " + e.getMessage(),
					Toast.LENGTH_LONG).show();
		}
	}

	public void turnOffLaser() {
		try {
			if (conexao.isConnected()) {
				Toast.makeText(super.getBaseContext(),
						"Laser OFF", Toast.LENGTH_SHORT).show();
				conexao.sendByte('L');
			} else
				Toast.makeText(getBaseContext(), "Erro na conexão",
						Toast.LENGTH_SHORT).show();
		} catch (Exception e) {
			Toast.makeText(getBaseContext(), "Erro: " + e.getMessage(),
					Toast.LENGTH_LONG).show();
		}
	}
	public void tes(){
		new AsyncGetImage().execute("yrdyr");
	}
	// AsyncTask para buscar imagem e atualizar GUI

	private class AsyncGetImage extends AsyncTask<String, Void, Bitmap> {

		protected Bitmap doInBackground(String... arg0) {
			Bitmap bm = null;
			char resp[] = new char[2];
			int s0 = 0;
			int s1 = 0;
			int s2 = 0;
			int s3 = 0;
			try {
				Thread.sleep(100);
				sensorManager.unregisterListener(sensorEventListener);
				do {
					conexao.cleanGarbage();
					conexao.sendByte('b');
					resp[0] = conexao.receiveByte();
					resp[1] = conexao.receiveByte();
				} while (resp[0] != '#' || resp[1] != 'b');


				conexao.cleanGarbage();

				// Read in header
					while (conexao.available() == 0) {
						conexao.sendByte('I');
					}

					while (conexao.receiveByte() != '#'
							|| conexao.receiveByte() != '#'
							|| conexao.receiveByte() != 'I'
							|| conexao.receiveByte() != 'M'
							|| conexao.receiveByte() != 'J'
							|| conexao.receiveByte() != '5');

					s0 = conexao.getIn().readUnsignedByte();
					s1 = conexao.getIn().readUnsignedByte();
					s2 = conexao.getIn().readUnsignedByte();
					s3 = conexao.getIn().readUnsignedByte();
					int val = 0 | s0 | s1 << 8 | s2 << 16 | s3 << 24;
					
					int bytesRead = 0;
					int bytesToRead = val;
					byte[] data = new byte[bytesToRead];
					while (bytesRead < bytesToRead) {
						int result = conexao.getIn().read(data, bytesRead, bytesToRead - bytesRead);
						if (result == -1)
							break;
						bytesRead += result;
					}
					bm = BitmapFactory.decodeByteArray(data, 0, val);
					
				} catch (Exception e) {}
				sensorManager.registerListener(sensorEventListener,
						(Sensor) sensorList.get(0),
						SensorManager.SENSOR_DELAY_NORMAL);
			return bm;
		}

		protected void onPostExecute(Bitmap bitmap) {
				if(bitmap == null)
					Toast.makeText(getBaseContext(), "Bitmap null",
							Toast.LENGTH_SHORT).show();
			iv.setImageBitmap(bitmap);
			iv.invalidate();
			tes();
		}

	}
}