package br.usp.icmc.lrm.gmarques.srv.sensor;

import android.content.Context;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import br.usp.icmc.lrm.gmarques.srv.network.Connection;

public class SRVSensorEventListener implements SensorEventListener {

	Connection conexao;
	int potenciaMaxima = 100;
	//Debug
	Context c;

	public SRVSensorEventListener(Connection conexao) {
		super();
		this.conexao = conexao;
	}
	
	//Debug
	public SRVSensorEventListener(Connection conexao, Context c) {
		super();
		this.conexao = conexao;
		this.c = c;
	}

	@Override
	public void onAccuracyChanged(Sensor arg0, int arg1) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onSensorChanged(SensorEvent event) {
		int motorEsquerdo = 0;
		int motorDireito = 0;
		int potenciaCentral = 0;

		float[] values = event.values;
		// float x = values[0];
		float y = values[1];
		float z = values[2];

		/*
		 * De 2 a -2 em Z manter reto. Para potencia maxima, Z vale 6 Entao,
		 * para potencia maxima (6-2)*25 = 127 (potencia maxima)
		 */

		if (z > 2) {
			potenciaCentral = (int) ((z - 2) * potenciaMaxima / 4);
			if (potenciaCentral > potenciaMaxima)
				potenciaCentral = potenciaMaxima;
		} else if (z < -2) {
			potenciaCentral = (int) ((z + 2) * potenciaMaxima / 4);
			if (potenciaCentral < -127)
				potenciaCentral = -127;
			potenciaCentral += 256;
		}
		motorDireito = potenciaCentral;
		motorEsquerdo = potenciaCentral;

		if (y > 1) {
			if (potenciaCentral <= 127) {
				motorDireito = (int) (potenciaCentral - (y - 1)
						* potenciaCentral / 6);
				if (motorDireito < 0)
					motorDireito = 0;
			} else {
				motorDireito = (int) (potenciaCentral + (y - 1)
						* potenciaCentral / 6);
				if (motorDireito > 255)
					motorDireito = 255;
			}
		} else if (y < -1) {
			if (potenciaCentral <= 127) {
				motorEsquerdo = (int) (potenciaCentral - (-(y + 1)
						* potenciaCentral / 6));
				if (motorEsquerdo < 0)
					motorEsquerdo = 0;
			} else {
				motorEsquerdo = (int) (potenciaCentral + (-(y + 1)
						* potenciaCentral / 6));
				if (motorEsquerdo > 255)
					motorEsquerdo = 255;
			}
		}

		try {
			conexao.sendByte('M');
			conexao.sendByte((char) motorDireito);
			conexao.sendByte((char) motorEsquerdo);
			conexao.sendByte((char) 200);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
